<?php

function flexinode_field_book_name($field) {
  return t('book_link');
}

function flexinode_field_book_form($field, &$node, $error) {
  $fieldname = 'flexinode_'. $field->field_id;
  $result = db_query(db_rewrite_sql('SELECT n.nid, n.title FROM {node} n INNER JOIN {book} b ON n.nid = b.nid WHERE b.parent = 0 ORDER BY b.weight, n.title'));
  while ($book = db_fetch_object($result)) {
     $options[$book->nid] = $book->title;
  }
  if (!is_array($node->$fieldname)) {
    $node->$fieldname = unserialize($node->$fieldname);
  }
  if (count($options)) {
    return form_select(t('Books'), $fieldname, $node->$fieldname, $options, t('The books to associate.') . ' ' . theme('error', $error[$fieldname]), 0, 1);
  }
}

function flexinode_field_book_db_select($field) {
  $fieldname = 'flexinode_'. $field->field_id;
  return $fieldname .'.textual_data AS '. $fieldname;
}

function flexinode_field_book_db_sort_column($field) {
  return 'flexinode_'. $field->field_id .'.textual_data';
}

function flexinode_field_book_insert($field, $node) {
  $fieldname = 'flexinode_'. $field->field_id;
  db_query("INSERT INTO {flexinode_data} (nid, field_id, textual_data) VALUES (%d, %d, '%s')", $node->nid, $field->field_id, serialize($node->$fieldname));
}

function flexinode_field_book_validate($field, $node) {
  $fieldname = 'flexinode_'. $field->field_id;
}

function flexinode_field_book_format($field, $node, $brief = 0) {
  $fieldname = 'flexinode_'. $field->field_id;

  $result = db_query(db_rewrite_sql('SELECT n.nid, n.title FROM {node} n INNER JOIN {book} b ON n.nid = b.nid WHERE b.parent = 0 ORDER BY b.weight, n.title'));
  while ($book = db_fetch_object($result)) {
     $options[$book->nid] = $book->title;
  }

  if(!is_array($node->$fieldname)) {
    $node->$fieldname = unserialize($node->$fieldname);
  }

  $output = '';  
  if ($node->$fieldname) {
    foreach($node->$fieldname as $key => $value) {
      $name = $options[$value];
      $output .= "<div class=\"related book\">".l($name, "node/".$value, array('title'=>'Related book'))."</div>";
    }
  }

  return $output;
}

/**
 * @addtogroup themeable
 * @{
 */

/**
 * Format a single-line text field for display in a node.
 *
 * @param field_id
 *   Which field is being displayed (useful when overriding this function
 *   if you want to style one particular field differently).
 * @param label
 *   The label for the field as displayed on the node form.
 * @param value
 *   The value that the user entered for the field.
 * @param formatted_value
 *   The value that the user entered for the field as pre-formatted by the module.
 */
function theme_flexinode_book($field_id, $label, $value, $formatted_value) {
  return theme('form_element', $label, $formatted_value);
}

/** @} End of addtogroup themeable */

?>
